local MAIN_SKIN= "waluigistriker"
local DROP_OBJ_ATTR= MAIN_SKIN..'dropped_obj'

if not this_template_allocation_run_only_once_give_a_unique_name_waluigistriker then
	rawset(_G, "this_template_allocation_run_only_once_give_a_unique_name_waluigistriker", true)
	
	freeslot("sfx_walssp")
	freeslot("MT_DROPPED_JOLTWA")
	freeslot("S_DROPPED_JOLTWA")
end

addHook("MobjThinker", function(mo)
	local target = mo.target
	if not(target and target.valid and target.player and
			target.skin==MAIN_SKIN and
			(target.player.kartstuff[k_spinouttimer] or target.player.playerstate==PST_DEAD)
		)
	then
		P_RemoveMobj(mo)
		return
	end
end, MT_DROPPED_JOLTWA)

local function spawn_object(player)
	local dropped_object= P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z+40*FRACUNIT, MT_DROPPED_JOLTWA)
	dropped_object.target= player.mo
    dropped_object.friction = 60*FRACUNIT/100
	dropped_object.color= player.skincolor
	P_SpawnShadowMobj(dropped_object)
end

addHook("ThinkFrame", do
	for player in players.iterate do
		if (not player.mo) or player.mo.skin~=MAIN_SKIN then continue end
		
		if (player.kartstuff[k_spinouttimer] or player.playerstate==PST_DEAD)
				and (not player[DROP_OBJ_ATTR])
		then
			player[DROP_OBJ_ATTR]= true
			spawn_object(player)
		elseif not (player.kartstuff[k_spinouttimer] or player.playerstate==PST_DEAD)
			and player[DROP_OBJ_ATTR]
		then
			player[DROP_OBJ_ATTR]= nil
		end
	end
end)

addHook("MobjThinker", function(mobj)
	if mobj.extravalue1 == 1 and S_SoundPlaying(mobj, mobj.info.attacksound)
	and mobj.tracer and mobj.tracer.valid and mobj.tracer.skin == "waluigistriker"
	and not S_SoundPlaying(mobj.tracer, sfx_walssp)
		S_StartSound(mobj.tracer, sfx_walssp)
	end
end, MT_SPB)